#include "winlib.h"

Win::Win()
{
}

Win::~Win()
{
Kill();
}
void Win::Init()
{
initscr();
start_color();
curs_set(2);
cbreak();
noecho();
init_pair(1,COLOR_WHITE,COLOR_BLUE);
init_pair(2,COLOR_RED,COLOR_BLUE);
init_pair(3,COLOR_BLACK,COLOR_CYAN);

mainwin = newwin(0,0,0,0);
filewin = newwin(LINES-6,3*COLS/5-1,5,1);

nodelay(filewin,true);

werase(mainwin);
wbkgd(mainwin,COLOR_PAIR(1));
wbkgd(filewin,COLOR_PAIR(1));
wattrset(mainwin,WA_BOLD);

keypad(filewin,true);

box(mainwin,0,0);
mvwaddstr(mainwin,1 , (COLS-title.length())/2 ,title.c_str());
wmove(mainwin,2,0);
whline(mainwin,ACS_LTEE,1);
wmove(mainwin,2,1);
whline(mainwin,ACS_HLINE,COLS-2);
wmove(mainwin,2,COLS-1);
whline(mainwin,ACS_RTEE,1);
wmove(mainwin,4,0);
whline(mainwin,ACS_LTEE,1);
wmove(mainwin,4,1);
whline(mainwin,ACS_HLINE,3*COLS/5-1);
wmove(mainwin,2,3*COLS/5);
wvline(mainwin,ACS_TTEE,1);
wmove(mainwin,3,3*COLS/5);
wvline(mainwin,ACS_VLINE,LINES-4);
wmove(mainwin,4,3*COLS/5);
whline(mainwin,ACS_PLUS,1);
wmove(mainwin,LINES-1,3*COLS/5);
wvline(mainwin,ACS_BTEE,1);
wmove(mainwin,4,3*COLS/5+1);
whline(mainwin,ACS_HLINE,2*COLS/5-2);
wmove(mainwin,4,COLS-1);
whline(mainwin,ACS_RTEE,1);

wmove(mainwin,(LINES-3)/2 + 2,3*COLS/5);
wvline(mainwin,ACS_LTEE,1);
wmove(mainwin,(LINES-3)/2 + 2,3*COLS/5+1);
whline(mainwin,ACS_HLINE,2*COLS/5-2);
wmove(mainwin,(LINES-3)/2 + 2,COLS-1);
whline(mainwin,ACS_RTEE,1);

wmove(mainwin,(LINES-3)/2 + 4,3*COLS/5);
wvline(mainwin,ACS_LTEE,1);
wmove(mainwin,(LINES-3)/2 + 4,3*COLS/5+1);
whline(mainwin,ACS_HLINE,2*COLS/5-2);
wmove(mainwin,(LINES-3)/2 + 4,COLS-1);
whline(mainwin,ACS_RTEE,1);

mvwaddstr(mainwin, 3 ,4*COLS/5 - info.length()/2, info.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 3 ,4*COLS/5 - help.length()/2, help.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 5 ,3*COLS/5 + 2,Hplay_pause.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 6 ,3*COLS/5 + 2,Hstop_enquee.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 7 ,3*COLS/5 + 2,Hnext_prev.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 8 ,3*COLS/5 + 2,Hff_rw.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 9 ,3*COLS/5 + 2,Hvol.c_str());
mvwaddstr(mainwin, (LINES-3)/2 + 10 ,3*COLS/5 + 2,Hquit.c_str());



mvwaddstr(mainwin, 6,3*COLS/5+1,"Tiempo\t:\t");
mvwaddstr(mainwin, 7,3*COLS/5+1,"Total\t:\t");

wnoutrefresh(mainwin);
doupdate();

}

void Win::FileWin(string path)
{
DIR *dd;
struct dirent *Dir;
char currentdir[512];
string blank;
int i=0;
struct stat isdir;
struct stat *pisdir;

pisdir = &isdir;
files.clear();
Maskfiles.clear();

dd = opendir(path.c_str());

chdir(path.c_str());

getcwd(currentdir,sizeof(currentdir));

werase(filewin);

wattron(filewin,A_BOLD);	wattron(filewin,A_BOLD);

blank = "";
for(int u = 1; u < 3*COLS/5-2;u++)
	blank += " ";

mvwaddstr(mainwin,3 , 1 , blank.c_str());
mvwaddnstr(mainwin,3 , 1 , currentdir,3*COLS/5-4);

while((Dir = readdir(dd)) != NULL)
	{
	if((Dir->d_name[0] == '.' && (Dir->d_name[1] == '.' || !Dir->d_name[1] ) ) || ( i >1 && Dir->d_name[0] != '.'))
		{
		stat(Dir->d_name,pisdir);

		files[i++] = Dir->d_name;
		Maskfiles[i-1] = files[i-1];

		if(S_ISDIR(pisdir->st_mode) )
			{
			Maskfiles[i-1] = "[" + Maskfiles[i-1] + "]";
			}

		if(Maskfiles[i-1].length() < 3*COLS/5)
			for(int fix= Maskfiles[i-1].length(); fix < 3*COLS/5 - 5; fix++)
				Maskfiles[i-1] += " ";
		}
	}

for(i = 0; i < files.size() ; i++)
	{
	mvwaddnstr(filewin, i , 2 , Maskfiles[i].c_str(), 3*COLS/5-4);
	}

wmove(filewin,0,2);
wnoutrefresh(mainwin);
wnoutrefresh(filewin);
doupdate();
}

void Win::FileWin(map<int,string>Files,string servername)
{
string blank;
int i=0;

NetFiles.clear();

servername = "MP3s en " + servername;
werase(filewin);

wattron(filewin,A_BOLD);	wattron(filewin,A_BOLD);

blank = "";
for(int u = 1; u < 3*COLS/5-2;u++)
	blank += " ";

mvwaddstr(mainwin,3 , 1 , blank.c_str());
mvwaddnstr(mainwin,3 , 1 , servername.c_str(),3*COLS/5-4);

for(i = 0; i < Files.size() ; i++)
	{
	NetFiles[i] = Files[i];
	mvwaddnstr(filewin, i, 2 , Files[i].c_str(), 3*COLS/5-4);
	}

wmove(filewin,1,2);
wnoutrefresh(mainwin);
wnoutrefresh(filewin);
doupdate();
}


int Win::GetCh()
{
return wgetch(filewin);
}

void Win::MoveWin(int UpOrDown)
{
int x,y,i,k = 5;

getsyx(y,x);

if(UpOrDown == DOWN && y <= LINES-2 && (y+lineshowed) < files.size()+4)
	{
	k =  4;
	if(files.size() > LINES-7 && y == LINES-2)
		{
		lineshowed++;
		scrollok(filewin, TRUE);
		wscrl(filewin, +1);
		scrollok(filewin, FALSE);
		mvwaddstr(filewin,LINES-7,2,Maskfiles[lineshowed+LINES-7].c_str());
		y = LINES-3;
		}
	}
else
if(UpOrDown == UP && y > 5 )
	{
	k = 6;
	if(files.size() > LINES-7 && y == 6 && lineshowed > 0)
		{
		lineshowed--;
		scrollok(filewin, TRUE);
		wscrl(filewin, -1);
		scrollok(filewin, FALSE);
		mvwaddstr(filewin,0,2,Maskfiles[lineshowed].c_str());
		y = 6;
		}
	}

mvwchgat(filewin,y-k,2,3*COLS/5, A_STANDOUT, COLOR_PAIR(3),NULL);
wrefresh(filewin);
}

void Win::ChDir()
{
int y,x,acceso;
string newdir;
char s[512];
struct stat isdir;
struct stat *pisdir;

pisdir = &isdir;

getsyx(y,x);

getcwd(s,sizeof(s));

newdir   = s;
newdir +=  "/"+ files[y-5];

lstat(newdir.c_str(),pisdir);

if(S_ISDIR(pisdir->st_mode) && ( access(newdir.c_str(),R_OK) == 0 )  )
	FileWin(newdir);
}

void Win::Kill()
{
delwin(mainwin);
delwin(filewin);
endwin();
}

void Win::WriteInfo(map<int,int>info)
{
char str[5];

sprintf(str,"%02d:%02d",info[0]/60,info[0] % 60);
mvwaddstr(mainwin,6,3*COLS/5 + 16,str);
sprintf(str,"%02d:%02d",info[1]/60,info[1] % 60);
mvwaddstr(mainwin,7,3*COLS/5 + 16,str);

string mpeg,layer,kbit,frec,modo;
sprintf(str,"%d",info[2]);
mpeg = "MPEG ";
mpeg += str;
mpeg += ".0";
mvwaddstr(mainwin,9,3*COLS/5 + 1,mpeg.c_str());

layer = "Layer ";
for(int i = 0; i < info[3] ; i++)
	{
	layer += "I";
	}

mvwaddstr(mainwin,9,3*COLS/5 + 2 + mpeg.length() ,layer.c_str());

sprintf(str,"%d",info[12]);
kbit = str;
kbit += " Kbit/s ";

mvwaddstr(mainwin,10,3*COLS/5 + 1,kbit.c_str());

sprintf(str,"%d",info[4]);
frec = str;
frec+= " Hz ";

mvwaddstr(mainwin,10,3*COLS/5 + 2 + kbit.length(),frec.c_str());

if(info[8] == 1)
	modo = "Mono";
else
if(info[8] == 2)
	modo = "Stereo";

mvwaddstr(mainwin,10,3*COLS/5 + 2 + kbit.length() + frec.length(),modo.c_str());

wrefresh(mainwin);

}

string Win::ToPlay()
{
int y,x;
char currentdir[512];
string mp3;

getsyx(y,x);
getcwd(currentdir,sizeof(currentdir));

mp3  = currentdir;
mp3+= "/" + files[y-5];

return mp3;
}


void Win::ShowVol(int vol)
{
char str[512];
string StrVol;

if(vol < 0)
	vol = 0;

sprintf(str,"%03d",vol&0xff);

StrVol = volume;
StrVol += str;
StrVol += " %";


mvwaddstr(mainwin, (LINES-3)/2 + 1 ,3*COLS/5 + 1 , StrVol.c_str());

wrefresh(mainwin);

}

int Win::ToSend()
{
int x,y;

getsyx(y,x);

return y;
}
