#include <ncurses.h>
#include <string>
#include <map>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>


#ifndef _WINLIB_H_
#define _WINLIB_H_

const string title ="329Player - MP3 Player basado en mpg123";
const string info  ="Informacin de Archivo";
const string help  ="Ayuda";
const string volume = "Volumen\t: ";
const string Hplay_pause ="[ X ] Play\t[ C ] Pause";
const string Hstop_enquee ="[ V ] Stop\t[ A ] Enquee";
const string Hnext_prev ="[ B ] Next\t[ P ] Prev";
const string Hff_rw ="[ N ] Rewind\t[ M ] Forward";
const string Hvol ="[+/-] Volumen";
const string Hquit ="[ Q ] Salir";

const int    UP    = -1;
const int    DOWN  = 1;
static int lineshowed = 0;

class Win
{
public:
	Win ();
	~Win ();
	map<int,string>files;
	map<int,string>Maskfiles;
	map<int,string>NetFiles;
	WINDOW *mainwin,*filewin;
	virtual void Init();
	virtual void FileWin(string);
	virtual void FileWin(map<int,string>,string);
	virtual int GetCh();
	virtual void Kill();
	virtual void MoveWin(int);
	virtual void ChDir();
	virtual void WriteInfo(map<int,int>);
	virtual void ShowVol(int);
	virtual string ToPlay();
	virtual int ToSend();
};


#endif
