#include <unistd.h>
#include <sys/socket.h>
#include <signal.h>
#include <string>
#include <cstdio>
#include <sys/resource.h>
#include <sys/timeb.h>
#include <unistd.h>
#include <map>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <fcntl.h>



#ifndef _CLASS_AUDIOLIB_
#define _CLASS_AUDIOLIB_

const int buffsize = 512;
static int lst = 0;
static int ready = 0;

class Audio
{
private:
	pid_t artsd;
	int mixer,dsp,left,right;
	char buf[buffsize];
	int arts_sender,arts_receiver,buflen;
public:
	Audio();
	~Audio();
	virtual int SetVolume(int);
	virtual int GetVolume();
	virtual bool Init();
	virtual void Kill();
};


class Mp3 : public Audio
{
private:
	pid_t mpg123;
	char buf[buffsize];
	int sender,receiver,buflen;
	bool playing;
	map<int,string>Quee;
public:
	Mp3();
	~Mp3();
	virtual bool Init();
	virtual void Open(string);
	virtual void Action(string,int);
	virtual bool GetInfo();
	virtual void HandleInfo(map<int,int>&FrameInfo);
	virtual bool Add(string);
	virtual void Kill();

};
#endif
